.section .data

.section .rodata
._Str0:
.byte	0x9,0x25,0x2e,0x30,0x34,0x66, 0
.section .data
	.align 8
_Float5:
	.long 0x0
	.long 0x3ff00000
	.align 8
_Float4:
	.long 0x0
	.long 0x0
	.align 8
_Float3:
	.long 0x0
	.long 0x0
	.align 8
_Float2:
	.long 0x0
	.long 0x3ff00000
	.align 8
_Float1:
	.long 0x0
	.long 0x0
	.align 8
_Float0:
	.long 0x0
	.long 0x0

.globl matrix_create
.globl vector_create
.globl matrix_destroy
.globl vector_destroy
.globl vector_copy
.globl matrix_copy
.globl vector_normalize
.globl matrix_normalize_rows
.globl matrix_col_from_vector
.globl vector_mul_matrix
.globl vector_mul_each_col
.globl vector_add_col
.globl matrix_mul_vector
.globl vector_sum
.globl matrix_sum_col
.globl matrix_sum_row
.globl vector_scale
.globl vector_print
.globl matrix_print
.section .text
matrix_print:
	pushl %ebp
	mov %esp, %ebp
	subl $36, %esp
	mov %ebx, -20(%ebp)
	mov %esi, -16(%ebp)
	mov $0, %eax
	movl %eax, -4(%ebp)
.L60:
	mov 12(%ebp), %eax
	mov -4(%ebp), %ebx
	mov 0(%eax), %ecx
	cmp %ecx, %ebx
	jge .L61
	mov $0, %eax
	movl %eax, -8(%ebp)
.L63:
	mov 12(%ebp), %eax
	mov -8(%ebp), %ebx
	mov 4(%eax), %ecx
	cmp %ecx, %ebx
	jge .L64
	movl %eax, -24(%ebp)
	movl %ebx, -28(%ebp)
	mov $._Str0, %eax
	mov 12(%ebp), %ebx
	mov -4(%ebp), %ecx
	lea 0(%ebx), %edx
	sal $2, %ecx
	add %ecx, %edx
	mov -8(%ebp), %ecx
	mov (%edx), %esi
	sal $3, %ecx
	add %ecx, %esi
	fldl (%esi)
	subl $8, %esp
	fstpl -44(%ebp)
	pushl %eax
	mov 8(%ebp), %eax
	pushl %eax
	movl %ebx, -32(%ebp)
	movl %edx, -36(%ebp)
	call fprintf
	addl $16, %esp
.L62:
	mov -8(%ebp), %eax
	inc %eax
	movl %eax, -8(%ebp)
	dec %eax
	jmp .L63
.L64:
	mov $10, %eax
	mov 8(%ebp), %ebx
	pushl %ebx
	pushl %eax
	call fputc
	addl $8, %esp
.L59:
	mov -4(%ebp), %eax
	inc %eax
	movl %eax, -4(%ebp)
	dec %eax
	jmp .L60
.L61:
	mov -20(%ebp), %ebx
	mov -16(%ebp), %esi
	addl $36, %esp
	pop %ebp
	ret


vector_print:
	pushl %ebp
	mov %esp, %ebp
	subl $28, %esp
	mov %ebx, -16(%ebp)
	mov $0, %eax
	movl %eax, -4(%ebp)
.L57:
	mov 12(%ebp), %eax
	mov -4(%ebp), %ebx
	mov 0(%eax), %ecx
	cmp %ecx, %ebx
	jge .L58
	movl %eax, -20(%ebp)
	movl %ebx, -24(%ebp)
	mov $._Str0, %eax
	mov 12(%ebp), %ebx
	mov -4(%ebp), %ecx
	lea 0(%ebx), %edx
	sal $3, %ecx
	add %ecx, %edx
	fldl (%edx)
	subl $8, %esp
	fstpl -36(%ebp)
	pushl %eax
	mov 8(%ebp), %eax
	pushl %eax
	movl %ebx, -28(%ebp)
	call fprintf
	addl $16, %esp
.L56:
	mov -4(%ebp), %eax
	inc %eax
	movl %eax, -4(%ebp)
	dec %eax
	jmp .L57
.L58:
	mov $10, %eax
	mov 8(%ebp), %ebx
	pushl %ebx
	pushl %eax
	call fputc
	addl $8, %esp
	mov -16(%ebp), %ebx
	addl $28, %esp
	pop %ebp
	ret


vector_scale:
	pushl %ebp
	mov %esp, %ebp
	subl $92, %esp
	mov %ebx, -16(%ebp)
	mov $0, %eax
	movl %eax, -4(%ebp)
.L54:
	mov 8(%ebp), %eax
	mov -4(%ebp), %ebx
	mov 0(%eax), %ecx
	cmp %ecx, %ebx
	jge .L55
	movl %eax, -20(%ebp)
	movl %ebx, -24(%ebp)
	mov 8(%ebp), %eax
	mov -4(%ebp), %ebx
	lea 0(%eax), %ecx
	sal $3, %ebx
	add %ebx, %ecx
	fldl (%ecx)
	fstpl -36(%ebp)
	fldl 12(%ebp)
	fstpl -48(%ebp)
	fldl -36(%ebp)
	fldl -48(%ebp)
	fmulp %st, %st(1)

	fstpl -60(%ebp)
	fldl -60(%ebp)
	fstpl -72(%ebp)
	fldl -72(%ebp)
	fstpl (%ecx)
	fldl (%ecx)
	fstpl -84(%ebp)
.L53:
	movl %eax, -88(%ebp)
	movl %ecx, -92(%ebp)
	mov -4(%ebp), %eax
	inc %eax
	movl %eax, -4(%ebp)
	dec %eax
	jmp .L54
.L55:
	mov -16(%ebp), %ebx
	addl $92, %esp
	pop %ebp
	ret


matrix_sum_row:
	pushl %ebp
	mov %esp, %ebp
	subl $156, %esp
	mov %ebx, -24(%ebp)
	mov $0, %eax
	mov 8(%ebp), %eax
	mov 12(%ebp), %ebx
	lea 0(%eax), %ecx
	sal $2, %ebx
	add %ebx, %ecx
	mov $0, %ebx
	mov (%ecx), %edx
	sal $3, %ebx
	add %ebx, %edx
	fldl (%edx)
	fstpl -36(%ebp)
	fldl (%edx)
	fstpl -48(%ebp)
	fldl -48(%ebp)
	fstpl -12(%ebp)
	mov $1, %eax
	movl %eax, -4(%ebp)
.L51:
	mov 8(%ebp), %eax
	mov -4(%ebp), %ebx
	mov 4(%eax), %ecx
	cmp %ecx, %ebx
	jge .L52
	movl %eax, -52(%ebp)
	movl %ebx, -56(%ebp)
	mov 8(%ebp), %eax
	mov 12(%ebp), %ebx
	lea 0(%eax), %ecx
	sal $2, %ebx
	add %ebx, %ecx
	mov -4(%ebp), %ebx
	mov (%ecx), %edx
	sal $3, %ebx
	add %ebx, %edx
	fldl -12(%ebp)
	fstpl -72(%ebp)
	fldl (%edx)
	fstpl -84(%ebp)
	fldl -72(%ebp)
	fldl -84(%ebp)
	faddp %st, %st(1)
	fstpl -96(%ebp)
	fldl -96(%ebp)
	fstpl -108(%ebp)
	fldl -108(%ebp)
	fstpl -12(%ebp)
	fldl -12(%ebp)
	fstpl -120(%ebp)
.L50:
	movl %eax, -124(%ebp)
	movl %ecx, -128(%ebp)
	movl %edx, -132(%ebp)
	mov -4(%ebp), %eax
	inc %eax
	movl %eax, -4(%ebp)
	dec %eax
	jmp .L51
.L52:
	fldl -12(%ebp)
	fstpl -144(%ebp)
	fldl -12(%ebp)
	fstpl -156(%ebp)
	fldl -156(%ebp)
	mov -24(%ebp), %ebx
	addl $156, %esp
	pop %ebp
	ret


matrix_sum_col:
	pushl %ebp
	mov %esp, %ebp
	subl $156, %esp
	mov %ebx, -24(%ebp)
	mov $0, %eax
	mov 8(%ebp), %eax
	mov $0, %ebx
	lea 0(%eax), %ecx
	sal $2, %ebx
	add %ebx, %ecx
	mov 12(%ebp), %ebx
	mov (%ecx), %edx
	sal $3, %ebx
	add %ebx, %edx
	fldl (%edx)
	fstpl -36(%ebp)
	fldl (%edx)
	fstpl -48(%ebp)
	fldl -48(%ebp)
	fstpl -12(%ebp)
	mov $1, %eax
	movl %eax, -4(%ebp)
.L48:
	mov 8(%ebp), %eax
	mov -4(%ebp), %ebx
	mov 0(%eax), %ecx
	cmp %ecx, %ebx
	jge .L49
	movl %eax, -52(%ebp)
	movl %ebx, -56(%ebp)
	mov 8(%ebp), %eax
	mov -4(%ebp), %ebx
	lea 0(%eax), %ecx
	sal $2, %ebx
	add %ebx, %ecx
	mov 12(%ebp), %ebx
	mov (%ecx), %edx
	sal $3, %ebx
	add %ebx, %edx
	fldl -12(%ebp)
	fstpl -72(%ebp)
	fldl (%edx)
	fstpl -84(%ebp)
	fldl -72(%ebp)
	fldl -84(%ebp)
	faddp %st, %st(1)
	fstpl -96(%ebp)
	fldl -96(%ebp)
	fstpl -108(%ebp)
	fldl -108(%ebp)
	fstpl -12(%ebp)
	fldl -12(%ebp)
	fstpl -120(%ebp)
.L47:
	movl %eax, -124(%ebp)
	movl %ecx, -128(%ebp)
	movl %edx, -132(%ebp)
	mov -4(%ebp), %eax
	inc %eax
	movl %eax, -4(%ebp)
	dec %eax
	jmp .L48
.L49:
	fldl -12(%ebp)
	fstpl -144(%ebp)
	fldl -12(%ebp)
	fstpl -156(%ebp)
	fldl -156(%ebp)
	mov -24(%ebp), %ebx
	addl $156, %esp
	pop %ebp
	ret


vector_sum:
	pushl %ebp
	mov %esp, %ebp
	subl $156, %esp
	mov %ebx, -24(%ebp)
	mov 8(%ebp), %eax
	mov $0, %ebx
	lea 0(%eax), %ecx
	sal $3, %ebx
	add %ebx, %ecx
	fldl (%ecx)
	fstpl -36(%ebp)
	fldl (%ecx)
	fstpl -48(%ebp)
	fldl -48(%ebp)
	fstpl -12(%ebp)
	mov $1, %eax
	movl %eax, -4(%ebp)
.L45:
	mov 8(%ebp), %eax
	mov -4(%ebp), %ebx
	mov 0(%eax), %ecx
	cmp %ecx, %ebx
	jge .L46
	movl %eax, -52(%ebp)
	movl %ebx, -56(%ebp)
	mov 8(%ebp), %eax
	mov -4(%ebp), %ebx
	lea 0(%eax), %ecx
	sal $3, %ebx
	add %ebx, %ecx
	fldl -12(%ebp)
	fstpl -72(%ebp)
	fldl (%ecx)
	fstpl -84(%ebp)
	fldl -72(%ebp)
	fldl -84(%ebp)
	faddp %st, %st(1)
	fstpl -96(%ebp)
	fldl -96(%ebp)
	fstpl -108(%ebp)
	fldl -108(%ebp)
	fstpl -12(%ebp)
	fldl -12(%ebp)
	fstpl -120(%ebp)
.L44:
	movl %eax, -124(%ebp)
	movl %ecx, -128(%ebp)
	mov -4(%ebp), %eax
	inc %eax
	movl %eax, -4(%ebp)
	dec %eax
	jmp .L45
.L46:
	fldl -12(%ebp)
	fstpl -144(%ebp)
	fldl -12(%ebp)
	fstpl -156(%ebp)
	fldl -156(%ebp)
	mov -24(%ebp), %ebx
	addl $156, %esp
	pop %ebp
	ret


matrix_mul_vector:
	pushl %ebp
	mov %esp, %ebp
	subl $272, %esp
	mov %ebx, -20(%ebp)
	mov %esi, -16(%ebp)
	mov %edi, -12(%ebp)
	pushl $12
	pushl $0
	leal -272(%ebp), %ecx
	push %ecx
	call memset
	addl $12, %esp
	mov 12(%ebp), %eax
	mov 0(%eax), %ebx
	mov %ebx, -264(%ebp)
	mov $8, %edx
	mov -264(%ebp), %esi
	movl %eax, -24(%ebp)
	mov %edx, %eax
	mul %esi
	mov %eax, -268(%ebp)
	movl %eax, -28(%ebp)
	movl %ebx, -32(%ebp)
	movl %esi, -36(%ebp)
	mov -272(%ebp), %ecx
	push %ecx
	call free
	addl $4, %esp
	mov -268(%ebp), %ecx
	push %ecx
	call malloc
	addl $4, %esp
	mov %eax, -272(%ebp)
	mov $0, %eax
	mov $0, %eax
	movl %eax, -4(%ebp)
.L39:
	mov 12(%ebp), %eax
	mov -4(%ebp), %ebx
	mov 0(%eax), %ecx
	cmp %ecx, %ebx
	jge .L40
	movl %eax, -40(%ebp)
	movl %ebx, -44(%ebp)
	mov -4(%ebp), %eax
	mov -272(%ebp), %ebx
	sal $3, %eax
	add %eax, %ebx
	mov 16(%ebp), %eax
	mov $0, %ecx
	lea 0(%eax), %edx
	sal $3, %ecx
	add %ecx, %edx
	mov 12(%ebp), %ecx
	mov -4(%ebp), %esi
	lea 0(%ecx), %edi
	sal $2, %esi
	add %esi, %edi
	mov $0, %esi
	movl %eax, -48(%ebp)
	mov (%edi), %eax
	sal $3, %esi
	add %esi, %eax
	movl %eax, -52(%ebp)
	fldl (%edx)
	fstpl -72(%ebp)
	mov -52(%ebp), %eax
	fldl (%eax)
	fstpl -84(%ebp)
	fldl -72(%ebp)
	fldl -84(%ebp)
	fmulp %st, %st(1)

	fstpl -96(%ebp)
	fldl -96(%ebp)
	fstpl -108(%ebp)
	fldl -108(%ebp)
	movl %eax, -52(%ebp)
	movl %ecx, -112(%ebp)
	movl %edx, -116(%ebp)
	movl %edi, -120(%ebp)
	fstpl (%ebx)
	mov $1, %eax
	movl %eax, -8(%ebp)
.L42:
	mov 12(%ebp), %eax
	mov -8(%ebp), %ebx
	mov 4(%eax), %ecx
	cmp %ecx, %ebx
	jge .L43
	movl %eax, -124(%ebp)
	movl %ebx, -128(%ebp)
	mov -4(%ebp), %eax
	mov -272(%ebp), %ebx
	sal $3, %eax
	add %eax, %ebx
	mov 16(%ebp), %eax
	mov -8(%ebp), %ecx
	lea 0(%eax), %edx
	sal $3, %ecx
	add %ecx, %edx
	mov 12(%ebp), %ecx
	mov -4(%ebp), %esi
	lea 0(%ecx), %edi
	sal $2, %esi
	add %esi, %edi
	mov -8(%ebp), %esi
	mov %ebx, -132(%ebp)
	mov (%edi), %ebx
	sal $3, %esi
	add %esi, %ebx
	movl %ebx, -136(%ebp)
	fldl (%edx)
	fstpl -156(%ebp)
	mov -136(%ebp), %ebx
	fldl (%ebx)
	fstpl -168(%ebp)
	fldl -156(%ebp)
	fldl -168(%ebp)
	fmulp %st, %st(1)

	fstpl -180(%ebp)
	mov -272(%ebp), %esi
	fldl (%esi)
	fstp -192(%ebp)
